<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 12/10/2005 *
 * ===============                              Last change: 12/10/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : reset_holiday.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Things to be done on daily reset                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Dinge, die beim taeglichen Reset erledigt werden *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif (!EXT_IS_ACTIVE('holiday')) {
	return;
}

// Do not execute when script is in CSS mode or no daily reset
if (($GLOBALS['output_mode'] == 1) || ((!isResetModeEnabled()) && (getConfig('holiday_mode') == "RESET"))) return;
//* DEBUG: */ echo basename(__FILE__)."<br />\n";

// Check for holidays we need to enable and send email to user
$result_main = SQL_QUERY("SELECT userid, holiday_activated
FROM `{!_MYSQL_PREFIX!}_user_data`
WHERE holiday_activated > 0 AND holiday_activated < UNIX_TIMESTAMP() AND `holiday_active`='N'
ORDER BY holiday_activated",
	__FILE__, __LINE__);

// Entries found?
if (SQL_NUMROWS($result_main) > 0) {
	// Init SQLs
	INIT_SQLS();

	// We have found at least one useraccount so let's check it...
	while ($content = SQL_FETCHARRAY($result_main)) {
		// Check if his holiday can be activated
		$result_holiday = SQL_QUERY_ESC("SELECT holiday_start, holiday_end
FROM `{!_MYSQL_PREFIX!}_user_holidays`
WHERE userid=%s AND holiday_start <= UNIX_TIMESTAMP() AND holiday_end > UNIX_TIMESTAMP()
LIMIT 1",
			array(bigintval($content['userid'])), __FILE__, __LINE__);
		if (SQL_NUMROWS($result_holiday) == 1) {
			// Okay, this user can be send away to holiday...
			$content = merge_array($content, SQL_FETCHARRAY($result_holiday));

			// Prepare all data for the template
			$content = array(
				'activated' => generateDateTime($content['holiday_activated'], '1'),
				'start'     => generateDateTime($content['holiday_start']    , '1'),
				'end'       => generateDateTime($content['holiday_end']      , '1')
			);

			// Send email to user
			$msg = LOAD_EMAIL_TEMPLATE("member_holiday_activated", $content, $content['userid']);
			sendEmail($content['userid'], getMessage('HOLIDAY_MEMBER_ACTIVATED_SUBJ'), $msg);

			// Update account
			ADD_SQL(SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data`
SET `holiday_active`='Y'
WHERE userid=%s
LIMIT 1",
				array(bigintval($content['userid'])), __FILE__, __LINE__, false));
		} // END - if

		// Free memory
		SQL_FREERESULT($result_holiday);
	} // END - while

	// Run all SQLs
	runFilterChain('run_sqls');
}

// Free memory
SQL_FREERESULT($result_main);

// Stop currently activated holidays
HOLIDAY_STOP_HOLIDAYS();

//
?>
